<script>
import { mapState, mapActions } from "vuex";

export default {
  name: "DefaultLayout",

  data() {
    return {
      isVisibleLayout: false,
      windowWidth: window.innerWidth,
      growTabs: false,
    };
  },

  computed: {
    ...mapState({
      user: (state) => state.user.user,
    }),

    organizationName() {
      return this.user?.name !== null
        ? this.user?.name
        : `Организация-${this.user.id}`;
    },

    formattedImagePath() {
      if (this.user?.avatar !== null) {
        return this.user?.avatar.url.full_size;
      } else {
        return require("../../assets/logo.svg");
      }
    },
  },

  methods: {
    ...mapActions({
      checkUser: "user/checkUser",
    }),

    exit() {
      localStorage.removeItem("user-token");
      location.href = "/auth";
    },

    onResize() {
      this.windowWidth = window.innerWidth;

      if (window.innerWidth <= 1024) {
        this.growTabs = true;
      } else {
        this.growTabs = false;
      }
    },
  },

  beforeMount() {
    this.checkUser().then(() => {
      this.isVisibleLayout = true;
    });
  },

  mounted() {
    this.$nextTick(() => {
      window.addEventListener("resize", this.onResize);
    });
  },

  beforeDestroy() {
    window.removeEventListener("resize", this.onResize);
  },
};
</script>

<template>
  <div v-if="isVisibleLayout" class="default-layout">
    <v-app-bar class="default-layout__nav nav" app color="white">
      <div class="nav__user user">
        <img
          :src="formattedImagePath"
          height="48"
          width="48"
          alt=""
          class="user__avatar"
        />

        <p>{{ organizationName }}</p>
      </div>

      <v-btn class="ml-6" color="info" small @click="exit">
        <v-icon left> mdi-exit-to-app </v-icon>
        Выйти
      </v-btn>

      <v-tabs class="nav__tabs" right height="100%" :grow="growTabs">
        <v-tab to="/">
          <v-icon left>mdi-home-city-outline</v-icon>Организация
        </v-tab>
        <v-tab to="/events">
          <v-icon left>mdi-guy-fawkes-mask</v-icon>Мероприятия
        </v-tab>
        <v-tab to="/volunteers">
          <v-icon left>mdi-account-outline</v-icon>Волонтеры
        </v-tab>
        `<v-tab :to="`/chat/${this.user.chat_id}`">
          <v-icon left>mdi-message-outline</v-icon>Чат организации
        </v-tab>
        <v-tab to="/integration">
          <v-icon left>mdi-information-outline</v-icon>Интеграция
        </v-tab>
      </v-tabs>
    </v-app-bar>

    <v-main>
      <div class="default-layout__page-wrapper">
        <router-view />
      </div>
    </v-main>
  </div>
</template>

<style lang="scss" scoped>
.default-layout {
  .nav {
    &__tabs {
      padding: 8px 0;
    }

    @media (max-width: 1024px) {
      height: auto !important;

      &__tabs {
        max-width: 100%;
        height: 56px;
        margin-top: 8px;
      }
    }
  }

  .user {
    display: flex;
    align-items: center;

    img {
      border-radius: 10px;
    }

    p {
      margin: 0 0 0 20px;
      font-size: 20px;
      white-space: nowrap;
    }
  }

  &__page-wrapper {
    height: calc(100vh - 64px);
    background-image: url("../../assets/images/default_background.svg");
    background-size: cover;

    @media (max-width: 1024px) {
      height: calc(100vh - 116px);
    }
  }
}
</style>
